/*
 
Copyright 2011 Serafino D'Angelillo <arriva-sera@hotmail.it>
 
This file is part of qiXD.
 
qiXD is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
 
qiXD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with qiXD.  If not, see
<http://www.gnu.org/licenses/>.
 
*/



#include "classifica.h"
#include <ncurses.h>
#include <fstream>
#include <cstring>


Classifica::Classifica()
{
}

void Classifica::caricaClassifica()
{
	ifstream in;
	in.open("classifica.dat");
	
	int n;
	string s;

	for(int i=0; i<5; i++)
	{
		in>> s;
		nomi[i] = s;
		in>> n;
		punteggi[i] = n;
	}

	in.close();
}


void Classifica::salvaClassifica()
{
	ofstream out;
	out.open("classifica.dat");

	for(int i=0; i<5; i++)
	{
		out<< nomi[i]<<endl;
		out<< punteggi[i]<<endl;
	}

	out.close();
}


void Classifica::stampaClassifica()
{
	erase();
	init_pair(41, COLOR_WHITE, COLOR_BLACK);
	init_pair(42, COLOR_WHITE, COLOR_WHITE);
	init_pair(43, COLOR_YELLOW, COLOR_BLACK);

	attron(COLOR_PAIR(42));
	mvprintw(1, 20, "**********");
	mvprintw(2, 20, "**");
	mvprintw(3, 20, "**");
	mvprintw(4, 20, "**");
	mvprintw(5, 20, "**********");

	mvprintw(1, 32, "**");
	mvprintw(2, 32, "**");
	mvprintw(3, 32, "**");
	mvprintw(4, 32, "**");
	mvprintw(5, 32, "********");

	mvprintw(1, 42, "********");
	mvprintw(2, 42, "**");		mvprintw(2, 48, "**");
	mvprintw(3, 42, "********");
	mvprintw(4, 42, "**");		mvprintw(4, 48, "**");
	mvprintw(5, 42, "**");		mvprintw(5, 48, "**");

	mvprintw(1, 52, "********");
	mvprintw(2, 52, "**");
	mvprintw(3, 52, "********");
	mvprintw(4, 58, "**");
	mvprintw(5, 52, "********");

	mvprintw(1, 62, "********");
	mvprintw(2, 62, "**");
	mvprintw(3, 62, "********");
	mvprintw(4, 68, "**");
	mvprintw(5, 62, "********");

	mvprintw(1, 72, "**");
	mvprintw(2, 72, "**");
	mvprintw(3, 72, "**");
	mvprintw(4, 72, "**");
	mvprintw(5, 72, "**");

	mvprintw(1, 76, "********");
	mvprintw(2, 76, "**");
	mvprintw(3, 76, "******");
	mvprintw(4, 76, "**");
	mvprintw(5, 76, "**");

	mvprintw(1, 86, "**");
	mvprintw(2, 86, "**");
	mvprintw(3, 86, "**");
	mvprintw(4, 86, "**");
	mvprintw(5, 86, "**");

	mvprintw(1, 90, "********");
	mvprintw(2, 90, "**");
	mvprintw(3, 90, "**");
	mvprintw(4, 90, "**");
	mvprintw(5, 90, "********");

	mvprintw(1, 100, "********");
	mvprintw(2, 100, "**");		mvprintw(2, 106, "**");
	mvprintw(3, 100, "********");
	mvprintw(4, 100, "**");		mvprintw(4, 106, "**");
	mvprintw(5, 100, "**");		mvprintw(5, 106, "**");

	attron(COLOR_PAIR(43));
	mvprintw(9, 50, "1.");
	attron(COLOR_PAIR(41));
	mvprintw(9, 55, "%s", nomi[0].c_str());
	mvprintw(10, 55, "%i", punteggi[0]);

	attron(COLOR_PAIR(43));
	mvprintw(12, 50, "2.");
	attron(COLOR_PAIR(41));
	mvprintw(12, 55, "%s", nomi[1].c_str());
	mvprintw(13, 55, "%i", punteggi[1]);

	attron(COLOR_PAIR(43));
	mvprintw(15, 50, "3.");
	attron(COLOR_PAIR(41));
	mvprintw(15, 55, "%s", nomi[2].c_str());
	mvprintw(16, 55, "%i", punteggi[2]);

	attron(COLOR_PAIR(43));
	mvprintw(18, 50, "4.");
	attron(COLOR_PAIR(41));
	mvprintw(18, 55, "%s", nomi[3].c_str());
	mvprintw(19, 55, "%i", punteggi[3]);

	attron(COLOR_PAIR(43));
	mvprintw(21, 50, "5.");
	attron(COLOR_PAIR(41));
	mvprintw(21, 55, "%s", nomi[4].c_str());
	mvprintw(22, 55, "%i", punteggi[4]);


	init_pair(13, COLOR_GREEN, COLOR_BLACK);
	init_pair(3, COLOR_WHITE, COLOR_BLACK);
	attron(COLOR_PAIR(13));
	mvprintw(27, 10, "PER USCIRE DALLA SCHERMATA PREMERE IL PULSANTE E");
	attron(COLOR_PAIR(3));
	
	refresh();

	int r;
	do{
		r = getch();
	}while(r != 'e');
}



void Classifica::aggiungiInClassifica(int newp)
{
	if( newp > punteggi[4])
	{
		punteggi[4] = newp;
		echo();

		erase();
		mvprintw(10,10, "Bravo, sei entrato nella classifica... inserisci il tuo nome");
		mvprintw(5, 10, "ATTENZIONE: QUANDO HAI FINITO DI SCRIVERE PREMI SPAZIO");
		string newn = "";
		int tmpc;
		curs_set(1);

		move(11, 10);

		timeout(-1);

		
		do{
			tmpc = getch();
			newn += static_cast<char>(tmpc);
		}while( tmpc != ' ');
		

		nomi[4] = newn;
		curs_set(0);
	}
	else
	{
		erase();
		mvprintw(13,30, "Spiacente non sei entrato in classifica");
		refresh();
		napms(3000);
	}

	noecho();
}



void Classifica::ordinaClassifica()
{
	bool scambio = false;


	do{
		scambio = false;		

		for(int i=0; i<4; i++)
		{
			if(punteggi[i] < punteggi[i+1])
			{
				int tp = punteggi[i];
				punteggi[i] = punteggi[i+1];
				punteggi [i+1] = tp;

				string tn = nomi[i];
				nomi [i] = nomi [i+1];
				nomi [i+1] = tn;

				scambio = true;
			}
		}

	}while(scambio);
}
