/*
 
Copyright 2011 Serafino D'Angelillo <arriva-sera@hotmail.it>
 
This file is part of qiXD.
 
qiXD is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
 
qiXD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with qiXD.  If not, see
<http://www.gnu.org/licenses/>.
 
*/


#include "funzioniS.h"
#include <ncurses.h>
#include <iostream>
using namespace std;

int FunzioniS::vite = 3;
bool FunzioniS::fineGioco = false;
int FunzioniS::contGenerale =0;
bool FunzioniS::persaVita = false;

int FunzioniS::tempd = 0;
int FunzioniS::temph = 0;
int FunzioniS::tempf = 0;

int FunzioniS::dimr = 28; 
int FunzioniS::dimc = 120; 
int FunzioniS::riqSu = 2;
int FunzioniS::riqGiu = 26; 
int FunzioniS::riqSx = 20; 
int FunzioniS::riqDx = 118;

int FunzioniS::percentuale = 0;
int FunzioniS::vperc = 0;
int FunzioniS::punteggio =0;

bool FunzioniS::iniziato = false;
char FunzioniS::dirInizio = 'n';
char FunzioniS::dirFine = 'n';

char FunzioniS::matriceGioco[25][99];


void FunzioniS::cacciaVita()
{
	FunzioniS::vite--;
	FunzioniS::persaVita = true;
}


void FunzioniS::inizializzaSchermo()
{
	curs_set(0);
	init_pair(1, COLOR_BLACK, COLOR_BLUE);
	init_pair(2, COLOR_BLUE, COLOR_BLUE);
	init_pair(3, COLOR_WHITE, COLOR_BLACK);
	init_pair(4, COLOR_WHITE, COLOR_BLACK);  //colore delle strisce cambialo da qui cambiando gli attibuti
	init_pair(5, COLOR_WHITE, COLOR_RED);
	init_pair(6, COLOR_GREEN, COLOR_GREEN);
	init_pair(7, COLOR_RED, COLOR_RED);
	init_pair(8, COLOR_WHITE, COLOR_WHITE);
	init_pair(9, COLOR_YELLOW, COLOR_BLACK);
	init_pair(10, COLOR_RED, COLOR_WHITE);
	init_pair(11, COLOR_RED, COLOR_BLACK);
	init_pair(12, COLOR_BLUE, COLOR_WHITE);
	init_pair(13, COLOR_GREEN, COLOR_BLACK);

	//colori per il Dominator
	init_pair(14, COLOR_RED, COLOR_BLACK);
	init_pair(15, COLOR_GREEN, COLOR_BLACK);
	init_pair(16, COLOR_YELLOW, COLOR_BLACK);
	init_pair(17, COLOR_BLUE, COLOR_BLACK);
	init_pair(18, COLOR_MAGENTA, COLOR_BLACK);
	init_pair(19, COLOR_CYAN, COLOR_BLACK);	



	keypad(stdscr, TRUE);

}


void FunzioniS::intro(Cursore &cur, Strisciatore &stri1, Strisciatore &stri2, Dominator &dom1, Dominator &dom2)
{
	FunzioniS::persaVita= false;

	erase();
	FunzioniS::percentuale = 0;
	FunzioniS::resettaMatriceGioco();
	FunzioniS::stampaSchermo();

	cur.inserisciInMatriceGioco(49, 24);
	stri1.inserisciInMatriceGioco();
	stri2.inserisciInMatriceGioco(0, 12);
	dom1.inserisciInMatriceGioco(49, 13);
	dom2.inserisciInMatriceGioco(47, 11);

	FunzioniS::countdown();
	
	FunzioniS::calcolaPercentuale();
	FunzioniS::calcolaPunteggio();

}

void FunzioniS::disegnaContorno()
{
	attron(COLOR_PAIR(4));
	for(int i=FunzioniS::riqSu; i<=FunzioniS::riqGiu; i++)
		for(int j =FunzioniS::riqSx; j<=FunzioniS::riqDx; j++)
		{
			if(FunzioniS::matriceGioco[i-2][j-20] != '0')
			{
				if(i == FunzioniS::riqSu)
				{
					mvprintw(i, j, "-");
					FunzioniS::matriceGioco[i-2][j-20] = '-';
				}

				if(i == FunzioniS::riqGiu)
				{
					mvprintw(i,j, "-");
					FunzioniS::matriceGioco[i-2][j-20] = '-';
				}

				if(j == FunzioniS::riqSx)
				{
					mvprintw(i,j, "|");
					FunzioniS::matriceGioco[i-2][j-20] = '|';
				}

				if(j == FunzioniS::riqDx)
				{
					mvprintw(i,j, "|");
					FunzioniS::matriceGioco[i-2][j-20] = '|';
				}
			}

		}
	attron(COLOR_PAIR(3));


}


void FunzioniS::stampaSchermo()
{
	attron(COLOR_PAIR(6));
	mvprintw(1,2, "*");
	mvprintw(1,3, "*");
	mvprintw(1,4, "*");
	mvprintw(1,5, "*");
	mvprintw(1,6, "*");
	mvprintw(2,2, "*");
	mvprintw(2,6, "*");
	mvprintw(3,2, "*");
	mvprintw(3,6, "*");
	mvprintw(4,2, "*");
	mvprintw(4,3, "*");
	mvprintw(4,4, "*");
	mvprintw(4,5, "*");
	mvprintw(4,6, "\\");
	mvprintw(3,5, "\\");

	attron(COLOR_PAIR(8));
	mvprintw(1,9, "*");
	mvprintw(2,9, "*");
	mvprintw(3,9, "*");
	mvprintw(4,9, "*");

	attron(COLOR_PAIR(7));
	mvprintw(1,12, "*");
	mvprintw(2,13, "*");
	mvprintw(3,14, "*");
	mvprintw(4,15, "*");
	mvprintw(1,15, "*");
	mvprintw(2,14, "*");
	mvprintw(3,13, "*");
	mvprintw(4,12, "*");
	attron(COLOR_PAIR(3));	




	mvprintw(7,3, "Percentuale: ");
	mvprintw(10, 3, "Obiettivo: ");
	mvprintw(11, 6, "75%");
	mvprintw(13, 3, "Punteggio: ");
	
	mvprintw(16, 3, "Vite: ");
	attron(COLOR_PAIR(11));
	if(FunzioniS::vite == 3)
	{
		mvprintw(17, 3, "0");
		mvprintw(17, 5, "0");
		mvprintw(17, 7, "0");
	}
	else if(FunzioniS::vite == 2)
	{
		mvprintw(17, 3, "0");
		mvprintw(17, 5, "0");
	}

	else if(FunzioniS::vite == 1)
	{
		mvprintw(17, 3, "0");
		
		FunzioniS::fineGioco = true;
	}
	attron(COLOR_PAIR(3));


	
	FunzioniS::disegnaContorno();

	refresh();

	FunzioniS::inizializzaMatriceGioco();
}

void FunzioniS::countdown()
{

	for(int i=0; i<4 ; i++)
	{

		if(FunzioniS::vite == 3)
			mvprintw(FunzioniS::riqGiu+2,(FunzioniS::dimc/2)-15, "ATTENZIONE: NON PREMERE TASTI");

		attron(COLOR_PAIR(8));

		if( i== 0)
		{
			mvprintw(21,6, "*");
			mvprintw(21,7, "*");
			mvprintw(21,8, "*");
			mvprintw(21,9, "*");
			mvprintw(21,10, "*");
			mvprintw(21,11, "*");

			mvprintw(22,11, "*");

			mvprintw(23,11, "*");
			mvprintw(23,10, "*");
			mvprintw(23,9, "*");
			mvprintw(23,8, "*");
			mvprintw(23,7, "*");
			mvprintw(23,6, "*");

			mvprintw(24,11, "*");

			mvprintw(25,11, "*");
			mvprintw(25,10, "*");
			mvprintw(25,9, "*");
			mvprintw(25,8, "*");
			mvprintw(25,7, "*");
			mvprintw(25,6, "*");
		}
		else if(i== 1)
		{
			mvprintw(21,6, "*");
			mvprintw(21,7, "*");
			mvprintw(21,8, "*");
			mvprintw(21,9, "*");
			mvprintw(21,10, "*");
			mvprintw(21,11, "*");

			mvprintw(22,11, "*");

			mvprintw(23,11, "*");
			mvprintw(23,10, "*");
			mvprintw(23,9, "*");
			mvprintw(23,8, "*");
			mvprintw(23,7, "*");
			mvprintw(23,6, "*");

			mvprintw(24,6, "*");

			mvprintw(25,11, "*");
			mvprintw(25,10, "*");
			mvprintw(25,9, "*");
			mvprintw(25,8, "*");
			mvprintw(25,7, "*");
			mvprintw(25,6, "*");
		}
		else if(i == 2)
		{
			mvprintw(21,11, "*");
			mvprintw(22,11, "*");
			mvprintw(23,11, "*");
			mvprintw(24,11, "*");
			mvprintw(25,11, "*");
		}	
		else	
		{
			attron(COLOR_PAIR(3));
			mvprintw(23,7, "INIZIO!");
		}

		refresh();
		napms(1000);

		attron(COLOR_PAIR(3));

		mvprintw(21,6, "      ");
		mvprintw(22,6, "      ");
		mvprintw(23,6, "        ");
		mvprintw(24,6, "      ");
		mvprintw(25,6, "      ");

		if (FunzioniS::vite == 3)
			mvprintw(FunzioniS::riqGiu+2,(FunzioniS::dimc/2)-15, "                              ");
	}

}

void FunzioniS::resettaMatriceGioco()
{

	for (int i=0; i<24; i++)
		for(int j= 0 ; j<98; j++)
			FunzioniS::matriceGioco[i][j] = '\0';

}



void FunzioniS::spostamentoCursore(int &movimento, Cursore &cur)
{
	if(movimento == KEY_LEFT )
		cur.moveToLeft();

	else if( movimento == KEY_RIGHT)
		cur.moveToRight();

	else if( movimento == KEY_UP)
		cur.moveToUp();

	else if( movimento == KEY_DOWN)
		cur.moveToDown();

	else if( movimento == ERR)
		refresh();
}


void FunzioniS::inizializzaMatriceGioco()
{
	for(int i=0; i<25; i++)
		for(int j=0; j<99; j++)
		{
			if(i == 0)
				FunzioniS::matriceGioco[i][j] = '-';

			if(i == 24)
				FunzioniS::matriceGioco[i][j] = '-';

			if(j == 0)
				FunzioniS::matriceGioco[i][j] = '|';

			if(j == 98)
				FunzioniS::matriceGioco[i][j] = '|';
		}
}


void FunzioniS::stampaMatriceGioco()
{
	for(int i=0; i<25; i++)
	{
		for(int j=0; j<99; j++)
		{
			if(FunzioniS::matriceGioco[i][j] == '\0')
				cout<< " ";
			else
				cout<< FunzioniS::matriceGioco[i][j];
		}
		cout<<endl;
	}
}



void FunzioniS::azzeraChiusuraBlocco()
{
	FunzioniS::iniziato = false;
	FunzioniS::dirInizio = 'n';
	FunzioniS::dirFine = 'n';
}



void FunzioniS::chiusuraBlocco()	
{
		//qui si vedrà l'inizio e la fine e si stabilirà quale lock eseguire

	//questo vale per D e R -- R e D -- U e D -- D e U -- D e D -- R e R -- U e R -- R e U -- U e U
	if(FunzioniS::dirInizio == 'd' && FunzioniS::dirFine == 'r'
		|| FunzioniS::dirInizio == 'd' && FunzioniS::dirFine == 'u'
		|| FunzioniS::dirInizio == 'u' && FunzioniS::dirFine == 'd'
		|| FunzioniS::dirInizio == 'r' && FunzioniS::dirFine == 'd'
		|| FunzioniS::dirInizio == 'r' && FunzioniS::dirFine == 'r'
		|| FunzioniS::dirInizio == 'u' && FunzioniS::dirFine == 'r'
		|| FunzioniS::dirInizio == 'r' && FunzioniS::dirFine == 'u'
		|| FunzioniS::dirInizio == 'u' && FunzioniS::dirFine == 'u'
		|| FunzioniS::dirInizio == 'd' && FunzioniS::dirFine == 'd')
		FunzioniS::lockDeR();

	else if(FunzioniS::dirInizio == 'd' && FunzioniS::dirFine == 'l'
		|| FunzioniS::dirInizio == 'l' && FunzioniS::dirFine == 'l'
		|| FunzioniS::dirInizio == 'l' && FunzioniS::dirFine == 'd'
		|| FunzioniS::dirInizio == 'l' && FunzioniS::dirFine == 'u'
		|| FunzioniS::dirInizio == 'u' && FunzioniS::dirFine == 'l')
		FunzioniS::lockDeL();

	else if( FunzioniS::dirInizio == 'l' && FunzioniS::dirFine == 'r'
		|| FunzioniS::dirInizio == 'r' && FunzioniS::dirFine == 'l')
		FunzioniS::lockLeR();

}


void FunzioniS::cambiaPinS()
{
	for(int i=0; i<25; i++)
		for(int j=0; j<99; j++)
			if(FunzioniS::matriceGioco[i][j] == 'p')
					FunzioniS::matriceGioco[i][j] = 's';
}




void FunzioniS::lockDeR()
{
	int cont1=0, cont2=0;
	bool trovatop = false;

	for(int i=1; i<24; i++)
	{
		for(int j=1; j<98; j++)
		{
			if(FunzioniS::matriceGioco[i][j] == 'p')
			{
				if(FunzioniS::matriceGioco[i][j+1] == '\0')
				{
					if((FunzioniS::matriceGioco[i+1][j] == 'p' || i+1 == 24)
						&& (FunzioniS::matriceGioco[i-1][j] == 'p' || i-1 == 0) )
					{
						if(!trovatop)
							trovatop= true;
						else
							trovatop= false;
					}

					else if( FunzioniS::matriceGioco[i+1][j] == 'p')
					{
						int tmpj= j;

						while( FunzioniS::matriceGioco[i][tmpj-1] == 'p')
							tmpj--;


						if(FunzioniS::matriceGioco[i-1][tmpj]== 'p')
						{
							if(!trovatop)
								trovatop= true;
							else
								trovatop= false;
						}

					}
					else if( FunzioniS::matriceGioco[i-1][j] == 'p')
					{
						int tmpj = j;

						while(FunzioniS::matriceGioco[i][tmpj-1] == 'p')
							tmpj--;

						if(FunzioniS::matriceGioco[i+1][tmpj] == 'p')
						{
							if(!trovatop)
								trovatop= true;
							else
								trovatop= false;
						}

					}



				}			
			}

			if(!trovatop && FunzioniS::matriceGioco[i][j] == '\0')
			{
				cont1++; 
				FunzioniS::matriceGioco[i][j] = 'a';
			}
			else if(trovatop && FunzioniS::matriceGioco[i][j] == '\0')
			{
				cont2++;
				FunzioniS::matriceGioco[i][j] = 'b';
			}

		}
		trovatop = false;
	}


	if(cont1 < cont2)
	{
		for(int i=1; i<24; i++)
			for(int j=1; j<98; j++)
			{
				if(FunzioniS::matriceGioco[i][j] == 'b')
					FunzioniS::matriceGioco[i][j] = '\0';
				
				if(FunzioniS::matriceGioco[i][j] == 'a')
					FunzioniS::matriceGioco[i][j] = 'c';

			}
	}
	else
	{
		for(int i=1; i<24; i++)
			for(int j=1; j<98; j++)
			{
				if(FunzioniS::matriceGioco[i][j] == 'a')
					FunzioniS::matriceGioco[i][j] = '\0';
				
				if(FunzioniS::matriceGioco[i][j] == 'b')
					FunzioniS::matriceGioco[i][j] = 'c';

			}
	}


}


void FunzioniS::lockDeL()
{
	int cont1=0, cont2=0;
	bool trovatop = false;

	for(int i=1; i<24; i++)
	{
		for(int j=97; j>0; j--)
		{
			if(FunzioniS::matriceGioco[i][j] == 'p')
			{
				if(FunzioniS::matriceGioco[i][j-1] == '\0')
				{
					if((FunzioniS::matriceGioco[i+1][j] == 'p' || i+1 == 24)
						&& (FunzioniS::matriceGioco[i-1][j] == 'p' || i-1 == 0) )
					{
						if(!trovatop)
							trovatop= true;
						else
							trovatop= false;
					}

					else if( FunzioniS::matriceGioco[i+1][j] == 'p')
					{
						int tmpj= j;

						while( FunzioniS::matriceGioco[i][tmpj+1] == 'p')
							tmpj++;


						if(FunzioniS::matriceGioco[i-1][tmpj]== 'p')
						{
							if(!trovatop)
								trovatop= true;
							else
								trovatop= false;
						}

					}
					else if( FunzioniS::matriceGioco[i-1][j] == 'p')
					{
						int tmpj = j;

						while(FunzioniS::matriceGioco[i][tmpj+1] == 'p')
							tmpj++;

						if(FunzioniS::matriceGioco[i+1][tmpj] == 'p')
						{
							if(!trovatop)
								trovatop= true;
							else
								trovatop= false;
						}

					}



				}			
			}

			if(!trovatop && FunzioniS::matriceGioco[i][j] == '\0')
			{
				cont1++; 
				FunzioniS::matriceGioco[i][j] = 'a';
			}
			else if(trovatop && FunzioniS::matriceGioco[i][j] == '\0')
			{
				cont2++;
				FunzioniS::matriceGioco[i][j] = 'b';
			}

		}
		trovatop = false;
	}


	if(cont1 < cont2)
	{
		for(int i=1; i<24; i++)
			for(int j=1; j<98; j++)
			{
				if(FunzioniS::matriceGioco[i][j] == 'b')
					FunzioniS::matriceGioco[i][j] = '\0';
				
				if(FunzioniS::matriceGioco[i][j] == 'a')
					FunzioniS::matriceGioco[i][j] = 'c';

			}
	}
	else
	{
		for(int i=1; i<24; i++)
			for(int j=1; j<98; j++)
			{
				if(FunzioniS::matriceGioco[i][j] == 'a')
					FunzioniS::matriceGioco[i][j] = '\0';
				
				if(FunzioniS::matriceGioco[i][j] == 'b')
					FunzioniS::matriceGioco[i][j] = 'c';

			}
	}


}


void FunzioniS::lockLeR()
{
	int cont1=0, cont2=0;
	bool trovatop = false;

	for(int j=1; j<98; j++)
	{
		for(int i=1; i<24; i++)
		{
			if(FunzioniS::matriceGioco[i][j] == 'p')
			{
				if(FunzioniS::matriceGioco[i+1][j] == '\0')
				{
					if((FunzioniS::matriceGioco[i][j+1] == 'p' || j+1 == 98)
						&& (FunzioniS::matriceGioco[i][j-1] == 'p' || j-1 == 0) )
					{
						if(!trovatop)
							trovatop= true;
						else
							trovatop= false;
					}

					else if( FunzioniS::matriceGioco[i][j-1] == 'p')
					{
						int tmpi= i;

						while( FunzioniS::matriceGioco[tmpi-1][j] == 'p')
							tmpi--;


						if(FunzioniS::matriceGioco[tmpi][j+1]== 'p')
						{
							if(!trovatop)
								trovatop= true;
							else
								trovatop= false;
						}

					}
					else if( FunzioniS::matriceGioco[i][j+1] == 'p')
					{
						int tmpi = i;

						while(FunzioniS::matriceGioco[tmpi-1][j] == 'p')
							tmpi--;

						if(FunzioniS::matriceGioco[tmpi][j-1] == 'p')
						{
							if(!trovatop)
								trovatop= true;
							else
								trovatop= false;
						}

					}



				}			
			}

			if(!trovatop && FunzioniS::matriceGioco[i][j] == '\0')
			{
				cont1++; 
				FunzioniS::matriceGioco[i][j] = 'a';
			}
			else if(trovatop && FunzioniS::matriceGioco[i][j] == '\0')
			{
				cont2++;
				FunzioniS::matriceGioco[i][j] = 'b';
			}

		}
		trovatop = false;
	}


	if(cont1 < cont2)
	{
		for(int i=1; i<24; i++)
			for(int j=1; j<98; j++)
			{
				if(FunzioniS::matriceGioco[i][j] == 'b')
					FunzioniS::matriceGioco[i][j] = '\0';
				
				if(FunzioniS::matriceGioco[i][j] == 'a')
					FunzioniS::matriceGioco[i][j] = 'c';

			}
	}
	else
	{
		for(int i=1; i<24; i++)
			for(int j=1; j<98; j++)
			{
				if(FunzioniS::matriceGioco[i][j] == 'a')
					FunzioniS::matriceGioco[i][j] = '\0';
				
				if(FunzioniS::matriceGioco[i][j] == 'b')
					FunzioniS::matriceGioco[i][j] = 'c';

			}
	}


}


void FunzioniS::disegnaBlocco()
{
	attron(COLOR_PAIR(2));

	for(int i= 1; i<24; i++)
		for(int j=1; j<98; j++)
			if(FunzioniS::matriceGioco[i][j] == 'c')
				mvprintw(i+2, j+20, " ");

	attron(COLOR_PAIR(3));

}


void FunzioniS::calcolaPercentuale() 
{
	double cont =0;

	for(int i= 1; i<24; i++)
		for(int j=1; j<98; j++)
			if(FunzioniS::matriceGioco[i][j] != '\0')
				cont++;

	double tmp = (cont/2231)*100;
	int perc = tmp;

	mvprintw(8,6, "%i", perc);

	FunzioniS::vperc = FunzioniS::percentuale;
	FunzioniS::percentuale = perc;
}


void FunzioniS::calcolaPunteggio()
{
	if(FunzioniS::percentuale != 0)
	{
		if(FunzioniS::percentuale > FunzioniS::vperc)
		{

			if(FunzioniS::percentuale - FunzioniS::vperc <6)
				FunzioniS::punteggio += 100;
			else if (FunzioniS::percentuale - FunzioniS::vperc <11)
				FunzioniS::punteggio += 200;
			else if (FunzioniS::percentuale - FunzioniS::vperc <16)
				FunzioniS::punteggio += 250;
			else if (FunzioniS::percentuale - FunzioniS::vperc <21)
				FunzioniS::punteggio += 400;
			else if (FunzioniS::percentuale - FunzioniS::vperc <31)
				FunzioniS::punteggio += 500;
			else if (FunzioniS::percentuale - FunzioniS::vperc <41)
				FunzioniS::punteggio += 800;
			else if (FunzioniS::percentuale - FunzioniS::vperc <51)
				FunzioniS::punteggio += 1000;
			else if (FunzioniS::percentuale - FunzioniS::vperc <61)
				FunzioniS::punteggio += 1200;
			else if (FunzioniS::percentuale - FunzioniS::vperc <71)
				FunzioniS::punteggio += 1600;
			else if (FunzioniS::percentuale - FunzioniS::vperc <81)
				FunzioniS::punteggio += 2000;
		}
	}

	mvprintw(14,6, "%i", FunzioniS::punteggio);
}
