/*
 
Copyright 2011 Serafino D'Angelillo <arriva-sera@hotmail.it>
 
This file is part of qiXD.
 
qiXD is free software: you can redistribute it and/or
modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
 
qiXD is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with qiXD.  If not, see
<http://www.gnu.org/licenses/>.
 
*/



#include "strisciatore.h"
#include "funzioniS.h"
#include <ncurses.h>
#include <ctime>
#include <cstdlib>


int Strisciatore::getSX() const
{
	return sx;
}

int Strisciatore::getSY() const
{
	return sy;
}

int Strisciatore::getSXG() const
{
	return sxg;
}

int Strisciatore::getSYG() const
{
	return syg;
}

char Strisciatore::getSC() const
{
	return sc;
}



Strisciatore::Strisciatore()
 :sx(FunzioniS::riqDx), sy((FunzioniS::riqGiu +FunzioniS::riqSu) /2),
	sxg(12), syg(98), sc('*')
{
}

void Strisciatore::inserisciInMatriceGioco()
{
	FunzioniS::matriceGioco[sxg][syg] = getSC();

	attron(COLOR_PAIR(9));
	mvprintw(sy, sx, "*");
	attron(COLOR_PAIR(3));
	move(sy, sx);
	refresh();

}


void Strisciatore::inserisciInMatriceGioco(int px, int py)
{
	syg = px;
	sxg = py;

	sx = syg+20;
	sy = sxg+2;

	inserisciInMatriceGioco();



}


void Strisciatore::muovi()
{
	direzione = scegliDirezione();

	switch(direzione)
	{
		case 0:
			//caso verticale con spostamento sopra
			if(sxg != 0 && (syg == 0 || syg ==98))
			{
				if(FunzioniS::matriceGioco[sxg-1][syg] == '0')
					FunzioniS::cacciaVita();
				else
				{
					attron(COLOR_PAIR(4));
					mvprintw(sy,sx, "|");
					attron(COLOR_PAIR(3));
					sy= sy-1;
					move(sy, sx);
					attron(COLOR_PAIR(9));
					printw("*");
					attron(COLOR_PAIR(3));
					move(sy,sx);
					refresh();

					FunzioniS::matriceGioco[sxg][syg] = '|';
					sxg--;
					FunzioniS::matriceGioco[sxg][syg] = '*';
				}

			}
			else if(sxg == 0 && (syg == 0 || syg ==98))
			{
				if(syg == 98)
				{
					attron(COLOR_PAIR(4));
					mvprintw(sy,sx, "-");
					attron(COLOR_PAIR(3));
					sx= sx-1;
					move(sy, sx);
					attron(COLOR_PAIR(9));
					printw("*");
					attron(COLOR_PAIR(3));
					move(sy,sx);
					refresh();

					FunzioniS::matriceGioco[sxg][syg] = '|';
					syg--;
					FunzioniS::matriceGioco[sxg][syg] = '*';
				}
				else if(syg == 0)
				{
					attron(COLOR_PAIR(4));
					mvprintw(sy,sx, "-");
					attron(COLOR_PAIR(3));
					sx= sx+1;
					move(sy, sx);
					attron(COLOR_PAIR(9));
					printw("*");
					attron(COLOR_PAIR(3));
					move(sy,sx);
					refresh();

					FunzioniS::matriceGioco[sxg][syg] = '|';
					syg++;
					FunzioniS::matriceGioco[sxg][syg] = '*';
				}
				
			}		

			//caso orizzontale con spostamento a sinistra
			if((sxg == 24 || sxg ==0) && (syg != 0 || syg !=98))
			{
				if(FunzioniS::matriceGioco[sxg][syg-1] == '0')
					FunzioniS::cacciaVita();
				
				else if( sxg == 0 && syg == 0)
				{
					attron(COLOR_PAIR(4));
					mvprintw(sy,sx, "|");
					attron(COLOR_PAIR(3));
					sy= sy+1;
					move(sy, sx);
					attron(COLOR_PAIR(9));
					printw("*");
					attron(COLOR_PAIR(3));
					move(sy,sx);
					refresh();


					FunzioniS::matriceGioco[sxg][syg] = '|';
					sxg++;
					FunzioniS::matriceGioco[sxg][syg] = '*';
				}
				else
				{
					attron(COLOR_PAIR(4));
					mvprintw(sy,sx, "-");
					attron(COLOR_PAIR(3));
					sx= sx-1;
					move(sy, sx);
					attron(COLOR_PAIR(9));
					printw("*");
					attron(COLOR_PAIR(3));
					move(sy,sx);
					refresh();

					FunzioniS::matriceGioco[sxg][syg] = '-';
					syg--;
					FunzioniS::matriceGioco[sxg][syg] = '*';
				}

			}

			

		

			break;
			
		case 1:
			//caso verticale con spostamento sotto
			if(sxg != 24 && (syg == 0 || syg ==98))
			{
				if(FunzioniS::matriceGioco[sxg+1][syg] == '0')
					FunzioniS::cacciaVita();
				else
				{
					attron(COLOR_PAIR(4));
					mvprintw(sy,sx, "|");
					attron(COLOR_PAIR(3));
					sy= sy+1;
					move(sy, sx);
					attron(COLOR_PAIR(9));
					printw("*");
					attron(COLOR_PAIR(3));
					move(sy,sx);
					refresh();


					FunzioniS::matriceGioco[sxg][syg] = '|';
					sxg++;
					FunzioniS::matriceGioco[sxg][syg] = '*';

				}

			}
			else if(sxg == 24 && (syg == 0 || syg ==98))
			{
				if(syg == 98)
				{
					attron(COLOR_PAIR(4));
					mvprintw(sy,sx, "-");
					attron(COLOR_PAIR(3));
					sx= sx-1;
					move(sy, sx);
					attron(COLOR_PAIR(9));
					printw("*");
					attron(COLOR_PAIR(3));
					move(sy,sx);
					refresh();

					FunzioniS::matriceGioco[sxg][syg] = '|';
					syg--;
					FunzioniS::matriceGioco[sxg][syg] = '*';
				}
				else if(syg == 0)
				{
					attron(COLOR_PAIR(4));
					mvprintw(sy,sx, "-");
					attron(COLOR_PAIR(3));
					sx= sx+1;
					move(sy, sx);
					attron(COLOR_PAIR(9));
					printw("*");
					attron(COLOR_PAIR(3));
					move(sy,sx);
					refresh();

					FunzioniS::matriceGioco[sxg][syg] = '|';
					syg++;
					FunzioniS::matriceGioco[sxg][syg] = '*';
				}
				
			}


			//caso orizzontale con spostamento a destra
			if((sxg == 0 || sxg ==24) && (syg != 0 || syg !=98))
			{
				if(FunzioniS::matriceGioco[sxg][syg+1] == '0')
					FunzioniS::cacciaVita();
			
				else if(sxg == 24 && syg == 98)
				{
					attron(COLOR_PAIR(4));
					mvprintw(sy,sx, "|");
					attron(COLOR_PAIR(3));
					sy= sy-1;
					move(sy, sx);
					attron(COLOR_PAIR(9));
					printw("*");
					attron(COLOR_PAIR(3));
					move(sy,sx);
					refresh();

					FunzioniS::matriceGioco[sxg][syg] = '|';
					sxg--;
					FunzioniS::matriceGioco[sxg][syg] = '*';

				}
				else
				{
					attron(COLOR_PAIR(4));
					mvprintw(sy,sx, "-");
					attron(COLOR_PAIR(3));
					sx= sx+1;
					move(sy, sx);
					attron(COLOR_PAIR(9));
					printw("*");
					attron(COLOR_PAIR(3));
					move(sy,sx);
					refresh();

					FunzioniS::matriceGioco[sxg][syg] = '-';
					syg++;
					FunzioniS::matriceGioco[sxg][syg] = '*';
				}

			}
				
			break;

	}

}


int Strisciatore::scegliDirezione()
{
	srand(time(0)); 
	
	int tmpd = rand();

	while(FunzioniS::tempd == tmpd)
		tmpd = rand();

	FunzioniS::tempd = tmpd;


	return tmpd %2;
	// a secondo 
	//se sono in verticale		0-sopra  1-sotto
	//se sono in orizzontale	0-sinistra  1-destra
}
